package ava.parser

object TokenDelimiter:

  val Space: Char          = ' '
  val NewLine: Char        = '\n'
  val CarriageReturn: Char = '\r'
  val Tab: Char            = '\t'
  val OpenParen: Char      = '('
  val CloseParen: Char     = ')'
  val Comma: Char          = ','
  val Colon: Char          = ':'
  val DoubleQuote: Char    = '"'
  val SingleQuote: Char    = '\''
  val Dot: Char            = '.'
  val BackSlash: Char      = '\\'
  val Tuple: Char          = '#'

  val WhiteSpace: List[Char] = List(
    Space,
    NewLine,
    CarriageReturn,
    Tab
  )

  val All: List[Char] = List(
    Space,
    NewLine,
    CarriageReturn,
    Tab,
    OpenParen,
    CloseParen,
    Comma,
    Colon,
    DoubleQuote,
    SingleQuote,
    Dot,
    BackSlash,
    Tuple
  )

  def isDelimiter(str: String): Boolean =
    if str.length() == 1 then isDelimiter(str.charAt(0))
    else false

  def isDelimiter(ch: Char): Boolean = All.contains(ch)

  def isWhiteSpace(ch: Char): Boolean = WhiteSpace.contains(ch)

end TokenDelimiter
