# Table of Contents

## Grammar

The entire Grammar is defined in [ava.ebnf](./ava.ebnf).

## Discussion

- [Keywords](keywords.md)
- [Operators & Symbols](operators-symbols.md)
- [Names](names.md)
- [Namespaces](namespaces.md)
- [General Syntax](general-syntax.md)
- [Expressions](expressions.md)
- [Standard Types](standard-types.md)
- [Values](values.md)
- [Constants](constants.md)
- [Arrays](arrays.md)
- [Lists](lists.md)
- [Variables](variables.md)
- [Tuples](tuples.md)
- [Records](records.md)
- [Enumerations](enumerations.md)
- [Types](types.md)
- [Type Aliases](type-aliases.md)
- [Type Classes](type-classes.md)
- [Type Unions](type-unions.md)
- [Pattern Matching](pattern-matching.md)
- [Functions](functions.md)
- [Infix Operators](infix-operators.md)
- [Recursion](recursion.md)
- [Strings](strings.md)
- [Memory Management](memory-management.md)
- [Holes](holes.md)
- [Examples](examples.md)
- [Standard Type Classes](standard-type-classes.md)
- [Numeric Overflow](numeric-overflow.md)
- [Standard Library](standard-library.md)
- [Effects](effects.md)
